/* The MIT License:

Copyright (c) 2009 Ivan Gagis

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE. */

/* 
 * File:   MainWindow.hpp
 * Author: ivan
 *
 * Created on February 23, 2009, 1:17 AM
 */

#pragma once

#ifndef M_NON_MAEMO_LINUX
//#include <hildonmm/window.h>
#include <hildonmm/stackable-window.h>
#include <hildonmm/app-menu.h>
#else
#include <gtkmm/window.h>
#include <gtkmm/menu.h>
#endif


#include <ting/types.hpp>
#include <ting/Signal.hpp>



//forward declarations
//...


class BasicWindow :
		public
#ifndef M_NON_MAEMO_LINUX
		Hildon::StackableWindow
#else
		Gtk::Window
#endif
{
	bool isRootWindow;

	bool isFullscreen;

#ifndef M_NON_MAEMO_LINUX
private:
	Hildon::AppMenu mainMenu;
protected:
	Gtk::Button optionsMenuItem;
#else
private:
	Gtk::Menu mainMenu;
protected:
	Gtk::MenuItem optionsMenuItem;
#endif


private:
	void ShowAboutDialog();

public:
	BasicWindow(bool rootWindow = false);
	~BasicWindow(){
//		TRACE(<< "~BasicWindow(): invoked" << std::endl)
	}

	bool OnKeyPress(GdkEventKey* event);
	void OnKeyPress_Notify(GdkEventKey* event);

private:
	void ToggleFullscreen();
};


